SystemOrganization addCategory: #'Ma traverse object graphs-API'!
SystemOrganization addCategory: #'Ma traverse object graphs-Info'!

!Set methodsFor: '*ma traverse object graphs' stamp: 'cmm 12/2/2004 17:29'!
maGraphDo: aBlock using: aObjectTraversalStrategy path: path with: alreadyVisitedSet
	"Sets and Dictionary's are enumerated logically."
	| varIndex |
	varIndex _ 1.
	self do:
		[ :each |
		self
			maValueGraphNode: each
			index: varIndex
			using: aObjectTraversalStrategy
			with: aBlock
			path: path
			with: alreadyVisitedSet.
		varIndex _ varIndex + 1 ]! !

Object subclass: #MaObjectGraphTraversalStrategy
	instanceVariableNames: 'valueWhenBlock traverseWhenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma traverse object graphs-API'!

!MaObjectGraphTraversalStrategy methodsFor: 'private' stamp: 'cmm 5/2/2005 22:13'!
initialize
	super initialize.
	valueWhenBlock := [:path :parent :instVarIndex | true].
	traverseWhenBlock := [:path :parent :instVarIndex | true]! !

!MaObjectGraphTraversalStrategy methodsFor: 'testing' stamp: ''!
shouldTraverseIntoLastOf: path from: parent index: anInteger

	^traverseWhenBlock
		value: path
		value: parent
		value: anInteger
! !

!MaObjectGraphTraversalStrategy methodsFor: 'testing' stamp: ''!
shouldValueLastOf: anOrderedCollection from: parentObject index: anInteger

	^valueWhenBlock
		value: anOrderedCollection
		value: parentObject
		value: anInteger
! !

!MaObjectGraphTraversalStrategy methodsFor: 'building' stamp: ''!
traverseWhen: threeArgBlock
	"The default traversal behavior is to traverse everything.  threeArgBlock
	may be specified to restrict the default traversal (stepping into an objects
	instance variables).  The first argument is an OrderedCollection of the
	path of objects that lead to the current node, the second is the parent
	of the current node (and second to last in the path), the last is the integer
	index of the instVar of the current node."

	traverseWhenBlock := threeArgBlock
! !

!MaObjectGraphTraversalStrategy methodsFor: 'building' stamp: ''!
valueWhen: threeArgBlock
	"The default behavior is to value every node once (the framework automatically
	keeps track of where it has already been).   threeArgBlock takes the same arguments
	as the other parameters of this class."

	valueWhenBlock := threeArgBlock
! !

!Object methodsFor: '*ma traverse object graphs' stamp: ''!
maGraphDo: threeArgBlock

	self
		maGraphWhere: [ :path :parent :index | true ]
		do: threeArgBlock
! !

!Object methodsFor: '*ma traverse object graphs' stamp: 'cmm 3/22/2010 18:25'!
maGraphDo: threeArgBlock using: anObjectTraversalStrategy
	"Walk the receiver and all of its variables valuing threeArgBlock.  The first argument is an OrderedCollection of the objects leading to the current object, including the current object, the second argument is the parent of the current object (second to last in the path).  The third argument is the index or key object required to send instVarAt: to access the current object (except for Dictionaries, in which the key may not be an Integer.  All arguments are in their substituted form."
	nil
		maValueGraphNode: self 
		index: 0
		using: anObjectTraversalStrategy 
		with: threeArgBlock
		path: OrderedCollection new 
		with: MaIdentitySet new! !

PackageInfo subclass: #MaTraverseObjectGraphsPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma traverse object graphs-Info'!

!MaTraverseObjectGraphsPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2009 16:19'!
packageName
	^ 'Ma traverse object graphs'! !

!MaTraverseObjectGraphsPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 3/23/2010 12:26'!
prerequisitePackageNames
	^ super prerequisitePackageNames , { 
			(MaProxySupportPackageInfo packageName).
			(MaSpecialCollectionsPackageInfo packageName)
		 }! !

!ProtoObject methodsFor: '*ma traverse object graphs' stamp: 'cmm 1/16/2005 13:43'!
maGraphDo: aBlock using: aObjectTraversalStrategy path: path with: alreadyVisitedSet
	"If this implementation changes, be sure to check subclasses below Collection which needed to copy this implementation."
	1
		to: self maInstSize
		do:
			[ :varIndex |
			self
				maValueGraphNode: (self instVarAt: varIndex)
				index: varIndex
				using: aObjectTraversalStrategy
				with: aBlock
				path: path
				with: alreadyVisitedSet ]
! !

!ProtoObject methodsFor: '*ma traverse object graphs' stamp: 'cmm 1/16/2005 13:56'!
maGraphWhere: threeArgConditionBlock do: threeArgBlock

	| strategy |

	strategy := MaObjectGraphTraversalStrategy new traverseWhen: threeArgConditionBlock.
	self
		maGraphDo: threeArgBlock
		using: strategy
! !

!ProtoObject methodsFor: '*ma traverse object graphs' stamp: 'cmm 2/4/2009 16:38'!
maValueGraphNode: anObject index: anInteger using: aObjectTraversalStrategy with: aBlock path: path with: alreadyVisitedSet 
	| stepInto obj |
	anObject == nil ifTrue: [ ^ anObject ].
	obj := anObject maIsMutatingProxy 
		ifTrue: 
			[ obj := (MaTraverseProxyNotification proxy: anObject) signal.
			"Never traverse or value a proxy.."
			(obj maIsMutatingProxy or: [ obj isNil ]) ifTrue: [ ^ self ].
			obj ]
		ifFalse: [ anObject ].
	(alreadyVisitedSet includes: obj) ifTrue: [ ^ obj ].
	path add: obj.
	stepInto := aObjectTraversalStrategy 
		shouldTraverseIntoLastOf: path
		from: self
		index: anInteger.
	(aObjectTraversalStrategy 
		shouldValueLastOf: path
		from: self
		index: anInteger) ifTrue: 
		[ alreadyVisitedSet add: obj.	"IMPORTANT, this needs to be here and not above.."
		aBlock 
			value: path
			value: self
			value: anInteger ].
	stepInto ifTrue: 
		[ obj 
			maGraphDo: aBlock
			using: aObjectTraversalStrategy
			path: path
			with: alreadyVisitedSet ].
	path removeLast! !

!Dictionary methodsFor: '*ma traverse object graphs' stamp: 'cmm 12/2/2004 17:29'!
maGraphDo: aBlock using: aObjectTraversalStrategy path: path with: alreadyVisitedSet

	| varIndex |

	varIndex := 1.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		[ : obj |
			self
				maValueGraphNode: obj
				index: varIndex
				using: aObjectTraversalStrategy
				with: aBlock
				path: path
				with: alreadyVisitedSet.
			varIndex := varIndex + 1 ]
				value: eachKey;
				value: eachValue ]! !
